# Monitorizarea traficului


## Wireshark
Wireshark este o aplicație folosită pentru analiza traficului de rețea de pe un
dispozitiv. Acesta se găsește în majoritatea repository-urilor și poate fi
instalat astfel: 

```Bash
sudo apt install wireshark
```

Pe Linux întâlnim conceptul de **network interface**. De exemplu `eth0` este
interfață pentru Ethernet (cablu), iar `wlp0s20f3` este de wireless. Pentru a
putea intercepta traficul pe o astfel de interfață trebuie să rulăm ca root.

```Bash
sudo wireshark
```

Wireshark are o interfață simplă -- pe fereastra ce se deschide vor apărea
interfețele disponibile. Pe calculatorul pe care a fost făcut screenshot-ul, apar
mai multe interfețe precum `wlp0s20f3`, `vmnet`, etc. 

![](images/wireshark1.png)

Pentru a începe capturarea traficului de pe o interfață, trebuie să selectăm
interfața, după care să dăm click pe butonul `Capture` din stânga sus.

Pachetele capturate apar în prima fereastră. Aici putem vedea diverse
informații, precum adresa sursă, protocolul, timpul la care a fost capurat
pachetul. Dacă dăm click pe un pachet, în fereastră de la mijloc vor apărea
toate informațiile despre acesta. În cazul de față, vedem un pachet
compus de trei protocoale: **Ethernet, Internet Protocol 4 (IPv4) și
Transmission Control Protocol (TCP)**. În fereastră, am extins doar conținutul
TCP al pachetului. Fereastră de jos indică conținutul pachetului sub formă de
octeți.

![](images/wireshark2.png)

**Bară de filtrare**. Wireshark permite filtrarea pachetelor: în bara unde
apare `Apply a display filter` putem adaugă filtre precum:


```
// Doar pachete ce au adresa IP sursa sau destinatia 192.0.2.1
ip.addr == 192.0.2.1
// Doar pachete tcp sau udp ce folosesc portul 80
// In laboratorul 6 vom discuta despre porturi
tcp.port == 80 || udp.port == 80
```
