# Endianness

In functie de ordinea in care un sir de octeti este **stocat in memorie** avem doua interpretari: **Little Endian** si **Big Endian**. Reprezentarea cu care suntem cel mai bine obisnuiti este Big Endian, asa cum reprezentam datele pe foaie, cel mai semnificativ byte este primul. In imaginea de mai jos avem un exemplu de cum un int pe 32 de biti, `0x01020304` poate avea valori diferite in functie de cum este interpretat. De notat faptul ca endianness-ul este acelasi pentru un char (1 byte)

![](images/endianness_figure1.webp)

In general, procesoarele moderne folosesc Little Endian. Totusi, placile de retea, folosesc Big Endian. O sa intalnim denumirea **Network Order (Big Endian)** si **Host Order (Little Endian)**.

In API-ul POSIX avem mai multe functii care se pot folosi pentru a face trecerea Host Order <-> Network Order:
```C
#include <arpa/inet.h>

// host to network long
uint32_t htonl(uint32_t hostlong); 
uint16_t htons(uint16_t hostshort); 
// network to host long
uint32_t ntohl(uint32_t netlong);
uint16_t ntohs(uint16_t netshort)
```