# Ethernet

Ethernet este echivalentul protocolului de DataLink pe care l-am implementat in
primele laboratoare. Noi vom lucra doar cu **cadre Ethernet** ce sunt transmise
ca payload peste implementarea protocolului de nivel fizic Ethernet. Cum CRC-ul
este calculat in hardware, nu o sa il regasim in header. In acest caz, header-ul
pe care il vom folosi este urmatorul:

```
Ethernet Frame
    +-----------------+------------+-------------+
    |     Bytes 0-5   | Bytes 6-11 | Bytes 12-13 |
    +------------------------------+-------------+
    | Destination MAC | Source MAC |  EtherType  |
    +-----------------+------------+-------------+
```
Adresa MAC Destinatie reprezinta identificatorul dispozitivului de nivel 2 catre
care a fost trimis acest cadru.

In cadrul laboratorului puteti folosi urmatoarea structura pentru un
cadru Ethernet. Pentru campul EtherType ne intereseaza doar valoarea
`ETHERTYPE_IP` (0x0800).

``` C
struct  ether_header {
    uint8_t  ether_dhost[6];
    uint8_t  ether_shost[6];
    uint16_t ether_type;     // ETHERTYPE_IP
};
```
