# Exercitii

In laboratorul de astazi vom implementa procesul de forwarding al unui router.
Topologia este una simpla, avem 4 dispozitive (hosts) conectate la un router

> **Scheletul laboratorului se regaseste la adresa de
[aici](https://gitlab.cs.pub.ro/pcom/pcom-laboratoare-public/-/tree/master/lab4). Functionalitatea disponibila este descrisa in README.md**

Vom folosi comanda `ping` pentru verifica conectivitatea intre hosts. Pentru
depanare vom folosi `Wireshark`.

Pe router va fi rulat manual programul rezultat in urma rularii comenzii
**make**. In cadrul laboratorului vom lucra in fisierul **router.c**.

**1\.** Vom deschide o instanta
de Wireshark pe router. Din oricare dintre hosti, trimiteti un `ping` catre un
alt host. Din Wireshark studiati pachetul primit. Este util de stiut faptul ca
Wireshark poate asculta in acelasi timp pe mai multe interfete (avem 4 pe
router).

Hostii au urmatoarele adrese alocate:
```
Host  IPv4         MAC   
host0 192.168.0.2  de:ad:be:ef:00:00
host1 192.168.1.2  de:ad:be:ef:00:01
host2 192.168.2.2  de:ad:be:ef:00:02
host3 192.168.3.2  de:ad:be:ef:00:03
```

**2\.** Implementati procesul de forward pentru IPv4. Tabela de rutare este
reprezentata printr-un array si poate fi accesata la un index prin
variabila `rtable[i]`. `rtable_size` este dimensiunea tabelei. Nu trebuie
implementata parsarea fisierului **rtable.txt**. Structura de date
utilizate pentru o intrare din tabela este `rtable_entry` din
`skel.h`.

**2.1.** Verificati integritatea header-ului IP folosind campul de checksum din
header. Daca acesta nu este bun, vom da drop la pachet.

**2.2.** Folosind algoritmul de LPM, determinati urmatorul hop si interfata pe care
va trebui sa trimitem pachetul.

**2.3.** Pentru fiecare pachet scadeti TTL-ul sau Hop Limit-ul; daca TTL-ul
este pozitiv, recalculati checksum-ul.

**2.4.** Actualizati header-ul Ethernet al pachetului. In functie de adresa IP a
destinatiei, vom cauta in tabela MAC adresa MAC a urmatorului hop. Tabela
este statica si putem interactiona cu ea folosind functiile din `skel.h`.

> Pentru a putea trimite pachetul IP mai departe, trebuie sa completam adresa MAC
a hostului urmator. In mode normal, tabela MAC este populata folosind protocolul ARP,
in cadrul acestui laborator vom considera o tabela statica deja populata folosind ARP

---
**Note**

Puteti folosi `inet_pton` a parsa adresele IPv4. Pentru a parsa MAC-ul in binar
puteti folosi functia `hwaddr_aton` pusa la dispozitie in **skel.h**.

Functia int `get_interface_mac(int interface, uint8_t *mac)` intoarce adresa MAC
a interfetei router-ului.

---
