# Procesul de forward (dirijiare)

Un router, pentru a trimite un pachet catre urmatorul dispozitiv (**hop**) va
trebui sa realizeze mai multe actiuni (proces de forward). Procesul complet de
forwarding este urmatorul:

1.  Pe una dintre interfete este receptionat un pachet IP.
2.  Verifica checksumul. Daca acesta este gresit, arunca pachetul
3.  Ruleaza algoritmul de **Longest Prefix Match (LPM)** in **tabela de rutare**
pentru a gasi urmatorul hop.
4.  In cazul in care nici o intrare din tabela nu face match, ruterul arunca
pachetul.
5.  Routerul decrementeaza campul TTL din header-ul IP. In cazul in care TTL
este 0, pachetul este aruncat.
6.  Recalcuelaza checksum-ul folosind formula incrementala descrisa anterior.
7.  Routerul face update la adresa MAC sursa a pachetului in adresa proprie
inainte de a il trimite la urmatorul HOP si adresa MAC destinatie a urmatorului
HOP.
8. Pachetul este trimis catre urmatorul hop identificat prin LPM

Urmatorul slideshow prezinta acest proces:
<iframe class="is-fullwidth" height="600" marginheight="0" marginwidth="0" src="slides/forwarding.html">
</iframe>

Tabela de rutare este populata de algoritmii de routare (nu o sa lucram cu ei la
PCom) si este structurata astfe:

```
Prefix      Mask             Next hop    Metric Interface
192.168.0.0 255.255.255.0   192.168.0.2     100    0
192.168.1.0 255.255.255.0   192.168.1.2     100    1
192.168.2.0 255.255.255.0   192.168.2.2     100    2
192.168.3.0 255.255.255.0   192.168.3.2     100    3
```

Un dispozitiv are mai multe interfete pe care poate trimite pachete (e.g. din
Londra, are una pentru Paris si una pentru Berlin). Metrica este folosita pentru
a indica link-uri mai bune. 
