# Longest Prefix Match


Pentru a determina prefixul dintr-o adresa IP si o masca, putem folosi
urmatoarea operatie pe biti: `ip & mask`. De exemplu:

```
 Adresa IP     Mask            Prefix
10.20.30.4 & 255.255.255.0 = 10.20.30.0
```
Algoritmul are o specificatie relativ simpla:
  - Routerul cauta in tabela de rutare intrarile care fac match pe adresa IP
  destinatie din pachetul IPv4. `(ip & mask) == prefix`
  - Dintre toate rutele pe care s-a facut match in etapa anterioara, este aleasa
  ruta cea mai specifica (adica ruta cu prefixul cel mai mare). Daca
  doua rute au aceeasi specificitate, se va folosi ruta cu cel mai mic metric.

Un exemplu este cel din urmatoarea imagine, in care routa a doua este cea
mai specifica si urmatorul hop este conectat pe interfata S1.

![](images/lpm.png)

Ruta 1 nu face match deoarece in acest caz `(destIp & mask) != prefix`. In schimb ruta 2 si 3 fac match. Totusi, dupa cum vedem si in imagine, ruta 2 este mai specifica.

O posibila implementare in `O(n)` a algoritmului este urmatoarea:

```C
// Avem o tabela de rutare table {prefix, mask, next_hop, interface}
// sorteaza table[i] descrescator dupa prefix, si masca
for (int i = 0; i < table_len; i++) {

    /* Cum tabela este sortata, primul match este prefixul ce mai specific */
    if (table[i].prefix == (target_ip & mask)) {
      return &table[i];
    }
}
```
