## Comunicare client-server UNIX

Intr-o arhitectura client-server, clientul trimite request-uri (cere
resurse) catre server, iar acesta din urma trimite inapoi un raspuns (cu
resursa).

Pasi urmati pentru a schimba mesaje folosind UDP la nivelul Transport
folosind API-ul de sockets sunt urmatorii:

1.  *Deschide un socket* unix in scopul de a permite comunicarea intre
    procese/statii diferite folosind descriptori de fisiere (file
    descriptors) cu apelul *socket()*.
2.  *Asociaza o adresa* pentru *socketul deschis* cu apelul *bind()*. In
    general, folosim *bind()* atunci cand dorim sa asteptam conexiuni pe
    un anumit port. Bind este chemat pe server pentru a specifica la ce
    port sa lege socket-ul.
3.  *Trimite/Receptioneaza date* cu apelul *recvfrom()/sendto()*.
4.  *Inchide socket* prin *close()*.

```
   +--------+            +--------+
   | Server |            | Client |
   +--------+            +--------+                 
       |                      |
       |                      |          Descriere:                                 
    socket()               socket()       socket() - creeaza un endpoint de comunicare
       |                      |           bind() - ataseaza o adresa unui socket
     bind()                   |           sendto() - trimite o datagrama
       |                      |           receive() - primeste o datagrama
    recv_from() <--------  sendto()       close() - elibereaza file descriptorul
       |                      |
    send_to()   -------->  recvfrom()
       |                      |
    close()                close()
```