## Transport reliable peste UDP

In unele cazuri, nu avem nevoie de transmisie reliable peste UDP (e.g.
streaming web unde daca pierdem cateva cadre, putem interpola la
receiver). Totusi, deseori avem nevoie sa stim cu certitudine ca un
mesaj a ajuns in partea cealalta. Pentru a rezolva aceasta problema vom
studia implementari de tip **sliding window**, mai exact cazul simplu in
care fereastra de transmisie este egala cu 1.

Un exemplu de protocol reliable peste UDP este Quick UDP Internet
Connections (QUIC) dezvoltat de Google in 2012.

### Stop and Wait

Unul dintre cele mai simple metode de a transmite datele peste un mediu
in care datagramele se pot pierde este protocolul stop and wait. In
cadrul protocolului, sender-ul va trimite un frame si la primirea unei
datagrame de ACK, va trimite urmatorul frame. Sender-ul foloseste un
timeout pentru retransmisie in cazul in care o datagrama este pierduta.

![](images/e-stop1.png)

Stop and wait este un caz particular de protocol ce foloseste sliding
windows, in cazul acesta windows\_size = 1. Pentru a intelege mai bine
conceptul de fereastra glsianta va recomandam urmatorul
[simulator](https://www2.tkn.tu-berlin.de/teaching/rn/animations/gbn_sr/)
ce implementeaza doi algoritmi diferiti: **go-back-n** si **selective
repeat**.

De notat faptul ca aceasta metoda este generala si nu se aplica doar la
nivelul transport. TCP foloseste o fereastra de transmitere, dar
intalnim acest concept si la nivele mai joase din stiva OSI.