## accept()

Ce se întâmplă în momentul în care un client încearcă să apeleze
*connect()* către o maşină şi un port pe care s-a facut în prealabil
*listen()*? Conexiunea va fi pusă în coada de aşteptare până în momentul
în care se face un apel de
[accept()](https://beej.us/guide/bgnet/html/#acceptthank-you-for-calling-port-3490)
de către server. Acest apel întoarce **un nou socket** care va fi
folosit pentru această conexiune:

``` C
#include <sys/types.h>
#include <sys/socket.h>

int accept(int sockfd, struct sockaddr *addr, socklen_t *addrlen);
/* Usage example: after calling listen we can call accept to accept a connection from the queue */
int len;
struct sockaddr_in cli;

/* cli and len are written by the call with the info about the connected client (e.g. port, address) */
connfd = accept(sockfd, (struct sockaddr *)&cli, &len);
```

Argumentul *sockfd* reprezintă socketul pe care s-a făcut *listen()*
(deci cel întors de apelul *socket()*). Funcția *accept()* întoarce un
nou socket, care va fi folosit pentru operații *send()* / *recv()*.
*addr* reprezintă un pointer spre o structură de tip *struct sockaddr*
în care se va afla informaţia despre conexiunea făcuta (ce maşină de pe
ce port a iniţiat conexiunea). Noul socket obţinut prin apelul
*accept()* va fi folosit în continuare pentru operaţiile de transmisie
și recepție de date.